<?php

namespace Thaolx\TrialPackage\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Thaolx\TrialPackage\Interfaces\TrialpackageRepositoryInterface;

class TrialpackagePublicController extends BaseController
{
    // use TrialpackageWorkflow;

    /**
     * Constructor.
     *
     * @param type \Thaolx\Trialpackage\Interfaces\TrialpackageRepositoryInterface $trialpackage
     *
     * @return type
     */
    public function __construct(TrialpackageRepositoryInterface $trialpackage)
    {
        $this->repository = $trialpackage;
        parent::__construct();
    }

    /**
     * Show trialpackage's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $trialpackages = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('trial_package::public.trialpackage.index', compact('trialpackages'))->render();
    }

    /**
     * Show trialpackage.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $trialpackage = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('trial_package::public.trialpackage.show', compact('trialpackage'))->render();
    }

}
